/*
  ARM  API ӿڿ
*/

#ifndef  __DONGLE_HEADER_H
#define  __DONGLE_HEADER_H

#include "winscard.h"
#pragma comment (lib, "winscard.lib")

#ifdef __cplusplus
extern "C" {
#endif

#ifndef         IN
    #define     IN
#endif

#ifndef         OUT
    #define     OUT
#endif

/************************************************************************/
/*                                                                  */
/************************************************************************/
//
typedef void * DONGLE_HANDLE;

//ĬϵPINԴΪ
//ʼʱͬʱʼPIDADMINPIN (PIDɸ, ADMINPINɸ)


#define CONST_PID                  0xFFFFFFFF   //ʱĬϵPID
#define CONST_USERPIN              "12345678"   //ʱĬϵUSERPIN
#define CONST_ADMINPIN             "FFFFFFFFFFFFFFFF" //ʱĬϵADMINPIN

//ͨѶЭͶ
#define PROTOCOL_HID               0 //hidЭ
#define PROTOCOL_CCID              1 //ccidЭ

//ļͶ
#define FILE_DATA                  1 //ͨļ
#define FILE_PRIKEY_RSA            2 //RSA˽Կļ
#define FILE_PRIKEY_ECCSM2         3 //ECCSM2˽Կļ(SM2˽ԿļECC˽Կļṹͬͬļ)
#define FILE_KEY                   4 //SM43DESԿļ
#define FILE_EXE                   5 //ִļ

//LED״̬
#define LED_OFF			           0 //
#define LED_ON			           1 //
#define LED_BLINK		           2 //

//PIN
#define FLAG_USERPIN   			   0 //ûPIN
#define FLAG_ADMINPIN			   1 //PIN

//ӽܱ־
#define FLAG_ENCODE                0 //
#define FLAG_DECODE                1 //

//HASH㷨
#define FLAG_HASH_MD5			   0 //MD5     16ֽ
#define FLAG_HASH_SHA1             1 //SHA1    20ֽ
#define FLAG_HASH_SM3              2 //SM3     32ֽ

//ԶĹܺ
#define UPDATE_FUNC_CreateFile     1 //ļ
#define UPDATE_FUNC_WriteFile      2 //дļ
#define UPDATE_FUNC_DeleteFile     3 //ɾļ
#define UPDATE_FUNC_FileLic        4 //ļȨ
#define UPDATE_FUNC_SeedCount      5 //
#define UPDATE_FUNC_DownloadExe    6 //ִļ
#define UPDATE_FUNC_UnlockUserPin  7 //ûPIN
#define UPDATE_FUNC_Deadline       8 //ʱʹ

/************************************************************************/
/*                              ṹ                                    */
/************************************************************************/
//RSAԿʽ(1024,2048)
typedef struct {
	unsigned int  bits;                   // length in bits of modulus
	unsigned int  modulus;				  // modulus
	unsigned char exponent[256];          // public exponent

} RSA_PUBLIC_KEY;

//RSA˽Կʽ(1024,2048)
typedef struct {
	unsigned int  bits;                   // length in bits of modulus
	unsigned int  modulus;                // modulus
	unsigned char publicExponent[256];    // public exponent
	unsigned char exponent[256];          // private exponent

} RSA_PRIVATE_KEY;

//ⲿECCSM2Կʽ ECC(֧bitsΪ192256)SM2(bitsΪ̶ֵ0x8100)Կʽ
typedef struct{
	unsigned int bits;                    // length in bits of modulus
	unsigned int XCoordinate[8];          // ϵX
	unsigned int YCoordinate[8];          // ϵY

} ECCSM2_PUBLIC_KEY;

//ⲿECCSM2˽Կʽ ECC(֧bitsΪ192256)SM2(bitsΪ̶ֵ0x8100)˽Կʽ
typedef struct{
	unsigned int bits;                    // length in bits of modulus
	unsigned int PrivateKey[8];           // ˽Կ

} ECCSM2_PRIVATE_KEY;

//Ϣ
typedef struct
{
	unsigned short  m_Ver;               //COS汾,:0x0201,ʾ2.01 
	unsigned short  m_Type;              //Ʒ: 0xFFʾ׼, 0x00Ϊ׼ʱ,0x02Ϊ׼U  
	unsigned char   m_BirthDay[8];       // 
	unsigned long   m_Agent;             //̱,:Ĭϵ0xFFFFFFFF
	unsigned long   m_PID;               //ƷID
	unsigned long   m_UserID;            //ûID
	unsigned char   m_HID[8];            //8ֽڵӲID
	unsigned long   m_IsMother;          //ĸ־: 0x01ʾĸ, 0x00ʾĸ
    unsigned long   m_DevType;           //豸(PROTOCOL_HIDPROTOCOL_CCID)

} DONGLE_INFO;

/**   
 *   ļ˵
 *   1.RSA˽ԿļΪ8
 *   2.ECCSM2˽ԿļΪ16
 *   3.3DES/SM4ԿļΪ32
 *   4.ִļΪ64,ܴСܳ64K
 *   5.ļڿռСļϵͳصӰ죬54
 *   6.ļIDȡֵΧΪ0x0000~0xFFFF֮䣬ID0x00000xFFFF0x3F00ϵͳռãûʹá
 */

/*************************ļȨṹ***********************************/
//ļȨṹ
typedef struct
{
	unsigned short  m_Read_Priv;     //Ȩ: 0ΪСȨޣ1ΪСûȨޣ2ΪСȨ
	unsigned short  m_Write_Priv;    //дȨ: 0ΪСȨޣ1ΪСûȨޣ2ΪСȨ

} DATA_LIC;

//˽ԿļȨṹ
typedef struct
{
	long           m_Count;        //ɵ: 0xFFFFFFFFʾ, ݼ0ʾѲɵ
	unsigned char  m_Priv;         //Ȩ: 0ΪСȨޣ1ΪСûȨޣ2ΪСȨ
	unsigned char  m_IsDecOnRAM;   //Ƿڴеݼ: 1Ϊڴеݼ0ΪFLASHеݼ
	unsigned char  m_IsReset;      //û̬úǷԶص̬: TRUEΪص̬ (̬ܴ)
	unsigned char  m_Reserve;      //,4ֽڶ

} PRIKEY_LIC;

//ԳƼ㷨(SM4/TDES)ԿļȨṹ
typedef struct
{
	unsigned long  m_Priv_Enc;   //ʱĵȨ: 0ΪСȨޣ1ΪСûȨޣ2ΪСȨ

} KEY_LIC;

//ִļȨṹ
typedef struct
{
	unsigned short  m_Priv_Exe;   //еȨ: 0ΪСȨޣ1ΪСûȨޣ2ΪСȨ
	
} EXE_LIC;

/****************************ļԽṹ********************************/
//ļݽṹ
typedef struct
{
	unsigned long    m_Size;      //ļȣֵΪ4096
	DATA_LIC         m_Lic;       //Ȩ
	
} DATA_FILE_ATTR;

//ECCSM2/RSA˽Կļݽṹ
typedef struct
{
	unsigned short  m_Type;       //:ECCSM2˽Կ  RSA˽Կ
	unsigned short  m_Size;       //ݳ:RSAֵΪ10242048, ECCֵΪ192256, SM2ֵΪ0x8100
	PRIKEY_LIC      m_Lic;        //Ȩ

} PRIKEY_FILE_ATTR;

//ԳƼ㷨(SM4/TDES)Կļݽṹ
typedef struct
{
	unsigned long  m_Size;       //Կݳ=16
	KEY_LIC        m_Lic;        //Ȩ

} KEY_FILE_ATTR;

//ִļݽṹ
typedef struct
{
	EXE_LIC         m_Lic;        //Ȩ	
	unsigned short  m_Len;        //ļ

} EXE_FILE_ATTR;

/*************************ļбṹ***********************************/
//ȡ˽Կļбʱصݽṹ
typedef struct
{
	unsigned short    m_FILEID;  //ļID
	unsigned short    m_Reserve; //,4ֽڶ
    PRIKEY_FILE_ATTR  m_attr;    //ļ

}PRIKEY_FILE_LIST;

//ȡSM4TDESԿļбʱصݽṹ
typedef struct
{
	unsigned short    m_FILEID;  //ļID
	unsigned short    m_Reserve; //,4ֽڶ
    KEY_FILE_ATTR     m_attr;    //ļ

}KEY_FILE_LIST;

//ȡļбʱصݽṹ
typedef struct
{
    unsigned short    m_FILEID;  //ļID
	unsigned short    m_Reserve; //,4ֽڶ
	DATA_FILE_ATTR    m_attr;    //ļ

}DATA_FILE_LIST;

//ȡִļбʱصݽṹ
typedef struct
{
	unsigned short  m_FILEID;    //ļID
	EXE_FILE_ATTR   m_attr;
	unsigned short  m_Reserve;  //,4ֽڶ
	
}EXE_FILE_LIST;

//غпִļʱݽṹ
typedef struct
{    
	unsigned short  m_dwSize;           //ִļС
	unsigned short  m_wFileID;          //ִļID
	unsigned char   m_Priv;             //Ȩ: 0ΪСȨޣ1ΪСûȨޣ2ΪСȨ
	unsigned char  *m_pData;            //ִļ

}EXE_FILE_INFO;

//Ҫĳʼ
typedef struct
{
	int    m_SeedLen;                 //볤
	BYTE   m_SeedForPID[256];         //ƷIDͿ (250ֽ)
	char   m_UserPIN[18];             //û(16ַ0ַֹ)
	BYTE   m_UserTryCount;            //ûԴ
	BYTE   m_AdminTryCount;           //Դ
	RSA_PRIVATE_KEY m_UpdatePriKey;   //Զ˽Կ
	DWORD  m_UserID_Start;            //ʼûID

} SON_DATA;

//ĸ
typedef struct
{
	SON_DATA  m_Son;                  //ʼ
	long      m_Count;                //ɲʼݵĴ (-1ʾƴ, ݼ0ʱ)

} MOTHER_DATA;

/**************************************************************************/
/*                                      API                               */
/**************************************************************************/

/** 
 * @brief  öټöٳ32hid豸32ccid豸
 *
 * @param  pDongleInfo     [out]     豸Ϣ顣˲ΪNULLʱ, pCountҵ豸Ŀ
 * @param  pCount 	       [out]     豸Ŀúͬʱöٳ32HID豸32CCID豸
 *
 * @return DONGLE_SUCCESS            ִгɹ
 */
DWORD WINAPI Dongle_Enum(DONGLE_INFO * pDongleInfo, int * pCount);

/**
 * @brief  ָļ
 *
 * @param  phDongle     [out]     ָ롣򿪳ɹ,ᱻ䡣
 * @param  nIndex       [in]      0ֵָʾҵĵڼѼ
 *
 * @return DONGLE_SUCCESS         򿪳ɹ
 */
DWORD WINAPI Dongle_Open(DONGLE_HANDLE * phDongle, int nIndex);

/**
 * @brief  PIN֤״̬״̬Ϊ
 *
 * @param  hDongle     [in]     򿪵ļ
 *
 * @return DONGLE_SUCCESS       ִгɹ
 */
DWORD WINAPI Dongle_ResetState(DONGLE_HANDLE hDongle);

/**
 * @brief  رմ򿪵ļ
 *
 * @param  hDongle     [in]     򿪵ļ
 *
 * @return DONGLE_SUCCESS       رճɹ
 */
DWORD WINAPI Dongle_Close(DONGLE_HANDLE hDongle);

/**
 * @brief  Ȩ޼ɲ
 *
 * @param  hDongle          [in]      򿪵ļ
 * @param  nLen             [in]      ҪĳȡnLenȡֵΧΪ 1~128
 * @param  pRandom          [out]     
 *
 * @return DONGLE_SUCCESS             ȡɹ
 */
DWORD WINAPI Dongle_GenRandom(DONGLE_HANDLE hDongle, int nLen, BYTE * pRandom);

/**
 * @brief  LEDƵĿƲȨ޼ɲ
 *
 * @param  hDongle     [in]     򿪵ļ
 * @param  nFlag       [in]     ͡磺nFlag = LED_ONʾLEDΪ״̬
 *                              nFlag = LED_OFFʾLEDΪ״̬nFlag = LED_BLINK
 *                              ʾLEDΪ˸״̬
 *
 * @return DONGLE_SUCCESS       ִгɹ
 */
DWORD WINAPI Dongle_LEDControl(DONGLE_HANDLE hDongle, int nFlag);

/**
 * @brief  лͨѶЭ顣ִгɹԶ,򿪵ľhDongleЧ,ִйرղ᷵
 *         0xF0000002Ĵ룬öٲòҪ֤PIN֮
 *	       󷽿ʹá
 *
 * @param  hDongle       [in]   򿪵ļ
 * @param  nFlag         [in]   Э͡磺nFlagֵΪPROTOCOL_HIDʾлΪHID豸
 *                              nFlagֵΪPROTOCOL_CCIDʾлΪCCID豸
 *
 * @return DONGLE_SUCCESS       ִгɹ
 */
DWORD WINAPI Dongle_SwitchProtocol(DONGLE_HANDLE hDongle, int nFlag);

/**
 * @brief  һָس״̬PIDûPIN롢PINȣȫָ״̬д
 *       ݶա⣬ִгɹԶ,򿪵ľhDongleЧ,ִйرղ
 *       ᷵0xF0000002Ĵ룬öٲòҪȨޡ
 *
 * @param  hDongle       [in]     򿪵ļ
 *
 * @return DONGLE_SUCCESS         ִгɹ
 */
DWORD WINAPI Dongle_RFS(DONGLE_HANDLE hDongle);

/**
 * @brief  ļúִֿ֧ļĴòҪȨޡ
 *
 * @param  hDongle       [in]     򿪵ļ
 * @param  nFileType     [in]     ļ͡
 *                                nFileType = FILE_DATAʾļļ˵
 *                                   1.ļСΪ252ֽʱ,ɴ54ļ,ռÿռ13608ֽ
 *                                   2.ļСΪ1024ֽʱ,ɴ31ļռÿռ31744ֽ
 *                                   3.ļСΪ4096ֽʱɴ9ļ,ռÿռ36864ֽ
 *                                nFileType = FILE_PRIKEY_RSAʾRSA˽Կļ
 *                                nFileType = FILE_PRIKEY_ECCSM2ʾECCSM2˽Կļ

 *                                nFileType = FILE_KEYʾSM43DESԿļ
 *                                ֧nFileType = FILE_EXEļ͡
 * @param  wFileID       [in]     ļID
 * @param  pFileAttr     [in]     ļԡĽṹΪDATA_FILE_ATTRPRIKEY_FILE_ATTRKEY_FILE_ATTR
 *
 * @return DONGLE_SUCCESS         ļɹ  
 */
DWORD WINAPI Dongle_CreateFile(DONGLE_HANDLE hDongle, int nFileType, WORD wFileID, void * pFileAttr);

/**
 * @brief  дļúִֿ֧ļдҸòҪȨޡ
 *
 * @param  hDongle       [in]     򿪵ļ
 * @param  nFileType     [in]     ļ͡磬
 *                                nFileType = FILE_DATAʾļ
 *                                nFileType = FILE_PRIKEY_RSAʾRSA˽Կļ
 *                                nFileType = FILE_PRIKEY_ECCSM2ʾECCSM2˽Կļ
 *                                nFileType = FILE_KEYʾSM43DESԿļ
 *                                ֧nFileType = FILE_EXEļ͡
 * @param  wFileID       [in]     ļID
 * @param  wOffset       [in]     ļƫơļдʼƫ
 * @param  pInData       [in]     ׼дݡ
 * @param  nDataLen      [in]     pInDataĴС
 *
 * @return DONGLE_SUCCESS         дļɹ
 */
DWORD WINAPI Dongle_WriteFile(DONGLE_HANDLE hDongle, int nFileType, WORD wFileID, WORD wOffset, BYTE * pInData, int nDataLen);

/**
 * @brief  ȡڵļļĶȡȨȡڴʱ趨
 *
 * @param  hDongle      [in]         򿪵ļ
 * @param  wFileID      [in]         ļID
 * @param  wOffset      [in]         ļƫ
 * @param  pOutData     [in]         ݻ
 * @param  nDataLen     [out]        pOutDataĳȡ
 *
 * @return DONGLE_SUCCESS            ȡļɹ  
 */
DWORD WINAPI Dongle_ReadFile(DONGLE_HANDLE hDongle, WORD wFileID, WORD wOffset, BYTE * pOutData, int nDataLen);

/**
 * @brief  ؿִļڿִļܳ64ִļܴСܳ64K
 *         òҪ֤ԱȨ
 *
 * @param  hDongle          [in]     򿪵ļ
 * @param  pExeFileInfo     [in]     ִļϢ顣
 * @param  nCount           [in]     ִļ
 * 
 * @return DONGLE_SUCCESS            ؿִļɹ
 */
DWORD WINAPI Dongle_DownloadExeFile(DONGLE_HANDLE hDongle, EXE_FILE_INFO * pExeFileInfo, int nCount);

/**
 * @brief  ָڿִгпִļȨޣȡʱÿִļã
 *         EXE_FILE_INFOеm_Privݵ󳤶Ȳܳ1024ֽڣݻ
 *         pInOutBufӦڵInOutBuf
 *
 * @param  hDongle            [in]             򿪵ļ
 * @param  wFileID            [in]             ִļļID
 * @param  pInOutBuf          [in,out]         ݻ
 * @param  wInOutBufLen       [in]             ݻpInOutBufĴС                                           
 * @param  pMainRet           [out]            ڿִгmainķֵΪNULL
 *
 * @return DONGLE_SUCCESS                  ָĿִļɹ
 */
DWORD WINAPI Dongle_RunExeFile(DONGLE_HANDLE hDongle, WORD wFileID, BYTE * pInOutBuf, WORD wInOutBufLen, int * pMainRet);

/**
 * @brief  ɾļҪȨޡ
 * 
 * @param  hDongle       [in]      򿪵ļ
 * @param  nFileType     [in]      ļ͡
 * @param  wFileID       [in]      ļID
 *
 * @return DONGLE_SUCCESS          ɾļɹ 
 */
DWORD WINAPI Dongle_DeleteFile(DONGLE_HANDLE hDongle, int nFileType, WORD wFileID);

/**
 * @brief ļҪȨޡ
 *
 * @param  hDongle       [in]         򿪵ļ
 * @param  nFileType     [in]         ָʾļ͡磬FILE_DATAȡ
 * @param  pFileList     [in]         pListļб (˲ΪNULLʱ, pLenзĻ)
 *                                    nFileType = FILE_DATAʱ,       pFileListָDATA_FILE_LISTṹ
 *                                    nFileType = FILE_PRIKEY_RSAʱ, pFileListָPRIKEY_FILE_LISTṹ
 *                                    nFileType = FILE_PRIKEY_ECCSM2ʱ, pFileListָPRIKEY_FILE_LISTṹ
 *                                    nFileType = FILE_KEYʱ,        pFileListָKEY_FILE_LISTṹ
 *	                                  nFileType = FILE_EXEʱ,        pFileListָEXE_FILE_LISTṹ
 * @param  pDataLen      [in,out]     pFileList볤ȣִгɹpFileListֽڳȡ
 *
 * @return DONGLE_SUCCESS             ļɹ
 */
DWORD WINAPI Dongle_ListFile(DONGLE_HANDLE hDongle, int nFileType, void* pFileList, int * pDataLen);

/**
 * @brief ΨһPIDͿPIN룬ҪȨޣִгɹԶص̬
 *		  PINĿΪʹ϶룬ĿPINԽDongle_ChangePIN
 *        иġ⣬һҪμǣκԶ޷֪PIN롣
 * 
 * @param hDongle		   [in]       򿪵ļ
 * @param nSeedLen		   [in]       pSeedĻȡ
 * @param pSeed            [in]       Ļ
 * @param pPIDStr          [out]      ִгɹPIDûСӦΪ8ֽڣһ
 *                                    8ֽڵ0ֹansiַ
 * @param pAdminPINstr     [out]      ִгɹؿPIN롣ûСӦΪ16ֽڣ
 *                                    ַΪ16ֽڵ0ֹansiַ
 *
 * @return DONGLE_SUCCESS             Ψһɹ
 */
DWORD WINAPI Dongle_GenUniqueKey(DONGLE_HANDLE hDongle,int nSeedLen, BYTE * pSeed, char * pPIDstr, char * pAdminPINstr);

/**
 * @brief  У
 *
 * @param  hDongle		    [in]       򿪵ļ
 * @param  nFlags           [in]       PIN͡ȡֵΪFLAG_USERPINFLAG_ADMINPIN
 * @param  pPIN             [in]       PIN룬0ֹansiַ
 * @param  pRemainCount     [out]      ʣԴ0ʾ1~253ʾʣ255ʾԴ
 *
 * @return DONGLE_SUCCESS              УɹУʧܣķֵҲʣԴ
 *                                     ( & 0xFFFFFF00) == DONGLE_INCORRECT_PINλʾʣ
 */
DWORD WINAPI Dongle_VerifyPIN(DONGLE_HANDLE hDongle, int nFlags, char * pPIN, int * pRemainCount);

/**
 * @brief  
 * 
 * @param  hDongle       [in]     򿪵ļ
 * @param  nFlags        [in]     PIN͡ȡֵΪFLAG_USERPINFLAG_ADMINPIN
 * @param  pOldPIN       [in]     ɵPIN뻺һַΪ16ֽڵ0ֹansiַ,ҿġ
 * @param  pNewPIN       [in]     µPIN뻺һַΪ16ֽڵ0ֹansiַ
 * @param  nTryCount     [in]     ԴòȡֵΧΪ1~255,255ʾԴ
 *
 * @return DONGLE_SUCCESS         ޸ɹ
 */
DWORD WINAPI Dongle_ChangePIN(DONGLE_HANDLE hDongle, int nFlags, char * pOldPIN, char * pNewPIN, int nTryCount);

/**
 * @brief  ûPIN롣(PID=FFFFFFFF)롣ִгɹûָΪĬ CONST_USERPIN
 *
 * @param  hDongle       [in]     򿪵ļ
 * @param  pAdminPIN     [in]     PIN뻺Ϊ16ֽڵ0ֹansiַ
 *
 * @return DONGLE_SUCCESS         ûPINɹ
 */
DWORD WINAPI Dongle_ResetUserPIN(DONGLE_HANDLE hDongle, char * pAdminPIN);

/**
 * @brief  ûIDҪȨޡ
 *
 * @param  hDongle      [in]     򿪵ļ
 * @param  dwUserID     [in]     ûID
 *
 * @return DONGLE_SUCCESS        ûPINɹ
 */
DWORD WINAPI Dongle_SetUserID(DONGLE_HANDLE hDongle, DWORD dwUserID);

/** 
 * @brief  ȡʱ䡣Ȩ޻ȡ
 *
 * @param  hDongle     [in]      򿪵ļ
 * @param  pdwTime     [out]     ȡĵUTCʱֵ
 *                               *pdwTime = 0XFFFFFFFFʾƵʱ
 *                               (*pdwTime & 0XFFFF0000) == 0ֵʾʣ༸Сʱ
 *                               (*pdwTime & 0XFFFF0000) != 0ֵʾڵUTCʱ䣬ͨgmtimeȽֵת
 *
 * @return DONGLE_SUCCESS        ȡʱɹ
 */
DWORD WINAPI Dongle_GetDeadline(DONGLE_HANDLE hDongle, DWORD * pdwTime);

/**
 * @brief  üĵʱ䡣òҪԱȨޡ
 * 
 * @param  hDongle     [in]     򿪵ļ                              
 * @param  dwTime      [in]     ʱֵ˵
 *                              1.ÿСʱΧ1~65535dwTime = 24УûPINʼʱ
 *                              2.õڵʱ롣ͨtimemktime ȡüʱutcʱֵ(utcֵ65535)
 *                              3.ȡʱƣʱdwTimeֵֻΪ0xFFFFFFFF
 *
 * @return DONGLE_SUCCESS       üʱɹ
 */
DWORD WINAPI Dongle_SetDeadline(DONGLE_HANDLE hDongle, DWORD dwTime);

/**
 * @brief  ȡUTCʱ䡣
 * 
 * @param  hDongle         [in]      򿪵ļ
 * @param  pdwUTCTime      [out]     UTCʱֵָ롣
 *
 * @return DONGLE_SUCCESS       üʱɹ
 */
DWORD WINAPI Dongle_GetUTCTime(DONGLE_HANDLE hDongle, DWORD * pdwUTCTime);

/**
 * @brief  ȡݡС8kǰ4k(0~4095)ĶдûȨƣ4k(4096~8191)Ȩ޿ɶ
 *         ֻпȨ޿д
 * 
 * @param  hDongle      [in]      򿪵ļ
 * @param  nOffset      [in]      ʼƫơΧ0~8191
 * @param  pData        [out]     ȡݻ
 * @param  nDataLen     [in]      pDataĻС
 *
 * @return  DONGLE_SUCCESS        ȡݳɹ 
 */
DWORD WINAPI Dongle_ReadData(DONGLE_HANDLE hDongle, int nOffset, BYTE* pData, int nDataLen);

/**
 * @brief  дݡС8kǰ4k(0~4095)ĶдûȨƣ4k(4096~8191)Ȩ޿ɶ
 *         ֻпȨ޿д
 * 
 * @param  hDongle      [in]      򿪵ļ
 * @param  nOffset      [in]      ʼƫơΧ0~8191
 * @param  pData        [in]      дݻ
 * @param  nDataLen     [in]      pDataĻС
 *
 * @return  DONGLE_SUCCESS        дݳɹ 
 */
DWORD WINAPI Dongle_WriteData(DONGLE_HANDLE hDongle, int nOffset, BYTE * pData, int nDataLen);

/**
 * @brief  ȡڴݡڴܴСΪ32ֽڡûȨƣԶ
 *
 * @param  hDongle     [in]      򿪵ļ
 * @param  pData       [out]     ݡڴݣ̶Ϊ32ֽڡ
 *
 * @return  DONGLE_SUCCESS       ȡڴݳɹ
 */
DWORD WINAPI Dongle_ReadShareMemory(DONGLE_HANDLE hDongle, BYTE * pData);

/**
 * @brief  ùڴݡûȨƣԶ
 * 
 * @param  hDongle      [in]     򿪵ļ
 * @param  pData        [in]     ݡ
 * @param  nDataLen     [in]     pDataĻСȲܳ32
 *
 * @return  DONGLE_SUCCESS       ùڴݳɹ
 */
DWORD WINAPI Dongle_WriteShareMemory(DONGLE_HANDLE hDongle, BYTE * pData, int nDataLen);

/**
 * @brief  RSAԿ˽Կʹøú֮ǰҪȴһRSA˽ԿļҪȨޡɹעⱣRSA˽Կݡ
 *
 * @param  hDongle        [in]      򿪵ļ
 * @param  wPriFileID     [in]      RSA˽ԿļID
 * @param  pPubBakup      [out]     RSAԿݡ
 * @param  pPriBakup      [out]     RSA˽Կݡ
 *
 * @return DONGLE_SUCCESS           RSA˽Կɹ 
 */
DWORD WINAPI Dongle_RsaGenPubPriKey(DONGLE_HANDLE hDongle, WORD wPriFileID, RSA_PUBLIC_KEY * pPubBakup, RSA_PRIVATE_KEY * pPriBakup);

/**
 * @brief  RSA˽Կ㡣ʹȨȡRSA˽ԿļȨޣRSA˽Կļʱ趨˵
 *         1.ڼ,ݳȱС˽ԿIDΪwPriFileIDԿȳ8ټȥ11,Աںڲpadding
 *         2.ڽ,ݳȱwPriFileIDָʾԿһ(1024λԿʱΪ1282048ʱΪ256)
 *         3.ʱڲpaddingʽΪ:PKCS1_TYPE_1 (ڶֽΪ0x01,0XFF)   
 *
 * @param  hDongle         [in]         򿪵ļ
 * @param  wPriFileID      [in]         RSA˽ԿļID
 * @param  nFlag           [in]         ͡磬FLAG_ENCODEʾ㣻FLAG_DECODEʾ㡣
 * @param  pInData         [in]         ݡ
 * @param  nInDataLen      [in]         pInDataĴС
 * @param  pOutData        [out]        ݻ
 * @param  pOutDataLen     [in,out]     pOutDataĴСͷصݴС
 *
 * @return DONGLE_SUCCESS               RSA˽Կɹ 
 */
DWORD WINAPI Dongle_RsaPri(DONGLE_HANDLE hDongle, WORD wPriFileID, int nFlag, BYTE * pInData, int nInDataLen, BYTE * pOutData, int * pOutDataLen);

/**
 * @brief  RSAԿ㡣Ȩ޿ɵá˵
 *         1.ڼ,ݳȱСpPubKeyָʾԿȳ8ټȥ11,Աںڲpadding
 *         2.ڽ,ݳȱpPubKeyָʾԿһ(1024λԿʱΪ1282048ʱΪ256)
 *         3.ʱڲpaddingʽΪ:PKCS1_TYPE_2 (ڶֽΪ0x02,)  
 *
 * @param  hDongle         [in]         򿪵ļ
 * @param  nFlag           [in]         ͡磬FLAG_ENCODEʾ㣻FLAG_DECODEʾ㡣
 * @param  pPubKey         [in]         RSAԿݡԴRSA˽ԿʱĹԿݡ
 * @param  pInData         [in]         ݡ
 * @param  nInDataLen      [in]         pInDataĴС
 * @param  pOutData        [out]        ݻ
 * @param  pOutDataLen     [in,out]     pOutDataĴСͷصݴС
 *
 * @return DONGLE_SUCCESS               RSAԿɹ
 */
DWORD WINAPI Dongle_RsaPub(DONGLE_HANDLE hDongle, int nFlag, RSA_PUBLIC_KEY * pPubKey, BYTE * pInData, int nInDataLen, BYTE * pOutData, int * pOutDataLen);

/**
 * @brief  ECCԿ˽Կʹøú֮ǰҪȴһECC˽ԿļҪȨޡɹעⱣECC˽Կݡ
 *
 * @param  hDongle        [in]      򿪵ļ
 * @param  wPriFileID     [in]      ECC˽ԿļID
 * @param  pPubBakup      [out]     ECCԿݡ
 * @param  pPriBakup      [out]     ECC˽Կݡ
 *
 * @return DONGLE_SUCCESS           ECC˽Կɹ 
 */
DWORD WINAPI Dongle_EccGenPubPriKey(DONGLE_HANDLE hDongle, WORD wPriFileID, ECCSM2_PUBLIC_KEY * pPubBakup, ECCSM2_PRIVATE_KEY * pPriBakup);

/**
 * @brief  ECC˽ԿǩʹȨȡECC˽ԿļȨޣECC˽Կļʱ趨˵
 *         1.ǩ㷨Ϊ: ECDSA_Sign
 *         2.HashֵĳECC˽ԿԿй(Կ192λ,hashֵȲܳ24(192/8 = 24)ֽ)
 *                                                    (Կ256λ,hashֵȲܳ32(256/8 = 32)ֽ)
 *         3.߲Ϊ:EC_NIST_PRIME_192EC_NIST_PRIME_256
 *
 * @param  hDongle          [in]      򿪵ļ
 * @param  wPriFileID       [in]      ECC˽ԿļID
 * @param  pHashData        [in]      Hashݡ
 * @param  nHashDataLen     [in]      pHashDataĴС
 * @param  pOutData         [out]     ǩݡС̶Ϊ64ֽ(256λECCʱ,192λECCʱλᲹ0)
 *
 * @return DONGLE_SUCCESS             ʾǩɹ
 */
DWORD WINAPI Dongle_EccSign(DONGLE_HANDLE hDongle, WORD wPriFileID, BYTE * pHashData, int nHashDataLen, BYTE * pOutData);

/**
 * @brief  ECCԿǩʹȨȡECC˽ԿļȨޣECC˽Կļʱ趨˵
 *         1.ǩ㷨Ϊ: ECDSA_Verify
 *         2.HashֵĳECC˽ԿԿй(Կ192λ,hashֵȲܳ24(192/8 = 24)ֽ)
 *                                                    (Կ256λ,hashֵȲܳ32(256/8 = 32)ֽ)
 *         3.߲Ϊ:EC_NIST_PRIME_192EC_NIST_PRIME_256
 *
 * @param  hDongle          [in]      򿪵ļ
 * @param  pPubKey          [in]      ECCԿݡ
 * @param  pHashData        [in]      Hashݡ
 * @param  nHashDataLen     [in]      pHashDataĴС
 * @param  pSign            [in]      ǩݡС̶Ϊ64ֽڣΪDongle_EccSignصpOutDataݡ
 *
 * @return DONGLE_SUCCESS             ʾǩɹ,ʾǩʧܡ
 */
DWORD WINAPI Dongle_EccVerify(DONGLE_HANDLE hDongle, ECCSM2_PUBLIC_KEY * pPubKey, BYTE * pHashData, int nHashDataLen, BYTE * pSign);

/**
 * @brief  SM2Կ˽Կʹøú֮ǰҪȴһSM2˽ԿļҪȨޡɹעⱣECC˽Կݡ
 *
 * @param  hDongle        [in]      򿪵ļ
 * @param  wPriFileID     [in]      SM2˽ԿļID
 * @param  pPubBakup      [out]     SM2Կݡ
 * @param  pPriBakup      [out]     SM2˽Կݡ
 *
 * @return DONGLE_SUCCESS           ECC˽Կɹ 
 */
DWORD WINAPI Dongle_SM2GenPubPriKey(DONGLE_HANDLE hDongle, WORD wPriFileID, ECCSM2_PUBLIC_KEY * pPubBakup, ECCSM2_PRIVATE_KEY * pPriBakup);

/**
 * @brief  SM2˽ԿǩʹȨȡSM2˽ԿļȨޣSM2˽Կļʱ趨
 *
 * @param  hDongle          [in]      򿪵ļ
 * @param  wPriFileID       [in]      SM2˽ԿļID
 * @param  pHashData        [in]      Hashݡ
 * @param  nHashDataLen     [in]      pHashDataĴСݳȱС32ֽڡ
 * @param  pOutData         [out]     ǩݡС̶Ϊ64ֽڡ
 *
 * @return DONGLE_SUCCESS             ʾǩɹ
 */
DWORD WINAPI Dongle_SM2Sign(DONGLE_HANDLE hDongle, WORD wPriFileID, BYTE * pHashData, int nHashDataLen, BYTE * pOutData);

/**
 * @brief  SM2ԿǩʹȨȡSM2˽ԿļȨޣSM2˽Կļʱ趨
 *
 * @param  hDongle          [in]      򿪵ļ
 * @param  wPriFileID       [in]      SM2Կݡ
 * @param  pHashData        [in]      Hashݡ
 * @param  nHashDataLen     [in]      pHashDataĴС
 * @param  pSign            [in]      ǩݡС̶Ϊ64ֽڣΪDongle_EccSignصpOutDataݡ
 *
 * @return DONGLE_SUCCESS             ʾǩɹ,ʾǩʧܡ
 */
DWORD WINAPI Dongle_SM2Verify(DONGLE_HANDLE hDongle, ECCSM2_PUBLIC_KEY * pPubKey, BYTE * pHashData, int nHashDataLen, BYTE * pSign);

/**
 * @brief  3DESӽܡȨ޼, ȨȡԿļȨޡ
 * 
 * @param  hDongle        [in]      򿪵ļ
 * @param  wKeyFileID     [in]      ԿļID
 * @param  nFlag          [in]      ͡磬FLAG_ENCODEʾ㣻FLAG_DECODEʾ㡣
 * @param  pInData        [in]      ݻ
 * @param  pOutData       [out]     ݻСҪݻͬݻΪͬһ
 * @param  nDataLen       [in]      pInDataݴСݳȱ16,ֵ1024
 *
 * @return DONGLE_SUCCESS           3DESܻɹ
 */
DWORD WINAPI Dongle_TDES(DONGLE_HANDLE hDongle, WORD wKeyFileID, int nFlag, BYTE * pInData, BYTE * pOutData, int nDataLen);

/**
 * @brief  SM4ӽܡȨ޼, ȨȡԿļȨޡ
 * 
 * @param  hDongle        [in]      򿪵ļ
 * @param  wKeyFileID     [in]      ԿļID
 * @param  nFlag          [in]      ͡磬FLAG_ENCODEʾ㣻FLAG_DECODEʾ㡣
 * @param  pInData        [in]      ݻ
 * @param  pOutData       [out]     ݻСҪݻͬݻΪͬһ
 * @param  nDataLen       [in]      pInDataݴСݳȱ16,ֵ1024
 *
 * @return DONGLE_SUCCESS           SM4ܻɹ
 */
DWORD WINAPI Dongle_SM4(DONGLE_HANDLE hDongle, WORD wKeyFileID, int nFlag, BYTE * pInData, BYTE * pOutData, int nDataLen);

/**
 * @brief  HASH㡣
 * 
 * @param  hDongle        [in]      򿪵ļ
 * @param  nFlag          [in]      Hash㷨͡
 *                                  nFlag = FLAG_HASH_MD5ʾMD5㣬ʱpHashĻСΪ16ֽڡ
 *                                  nFlag = FLAG_HASH_SHA1ʾSHA1㣬ʱpHashĻСΪ20ֽڡ
 *                                  nFlag = FLAG_HASH_SM3ʾSM3㣬ʱpHashĻСΪ32ֽڡ
 * @param  pInData        [in]      ݻ
 * @param  nDataLen       [in]      pInDataݴСSHA1MD5Ϊ㣬ȲƣSM3Ϊ㣬
 *                                  󲻳1024ֽڡ
 * @param  pHash          [out]     Hashֵ
 *
 * @return DONGLE_SUCCESS           HASHɹ
 */
DWORD WINAPI Dongle_HASH(DONGLE_HANDLE hDongle, int nFlag, BYTE * pInData, int nDataLen, BYTE * pHash);

/**
 * @brief  㷨Ȩ޿ʹ, ̿ÿ
 *         1.㷨PIDйأ(PID=FFFFFFFF)ܽ㡣
 *         2.ڲΪ-1ݼ0˺ʹá
 *
 * @param  hDongle        [in]      򿪵ļ
 * @param  pSeed          [in]      ݡ 
 * @param  nSeedLen       [in]      볤ȡȡֵΧΪ1~250ֽڡ
 * @param  pOutData       [out]     ݻĴС̶Ϊ16ֽڡ
 *
 * @return DONGLE_SUCCESS           ɹ
 */
DWORD WINAPI Dongle_Seed(DONGLE_HANDLE hDongle, BYTE * pSeed, int nSeedLen, BYTE * pOutData);

/**
 * @brief 㷨ҪȨޡ
 *
 * @param  hDongle     [in]      򿪵ļ
 * @param  nCount      [in]      ֵΪ-1ʾ
 * 
 * @return DONGLE_SUCCESS        óɹ
 */
DWORD WINAPI Dongle_LimitSeedCount(DONGLE_HANDLE hDongle, int nCount);

/**
 * @brief  һĸĸķʽһֿѡĳʼʽȫֿ٣ƼʹáҪȨޡ
 *         1.(PID=FFFFFFFF)дĸݡ
 *	       2.ڰȫ,MOTHER_DATAеԶ˽ԿĸԶ˽Կͬ,ʧܡ
 *
 * @param  hDongle     [in]      򿪵ļ
 * @param  pInData     [in]      ݡڳʼĸĽṹΪMOTHER_DATAݡ
 *
 * @return DONGLE_SUCCESS        ĸɹ
 */
DWORD WINAPI Dongle_GenMotherKey(DONGLE_HANDLE hDongle, MOTHER_DATA * pInData);

/**
 * @brief  ӿȡ󡣴˺ֻPIDΪFFFFFFFFĿЧҪȨޡ
 *
 * @param  hDongle      [in]       򿪵ļ
 * @param  pRequest     [out]      ݡظݵЧΪ16ֽڣҪ16ֽڵĿռ䡣
 *
 * @return DONGLE_SUCCESS          ȡݳɹ
 */
DWORD WINAPI Dongle_RequestInit(DONGLE_HANDLE hDongle, BYTE * pRequest);

/**
 * @brief  ĸȡڳʼݣúֻĸЧȨ޿ʹá
 *
 * @param  hDongle       [in]          򿪵ļ
 * @param  pRequest      [in]          ݡͨDongle_RequestInitȡݡ
 * @param  pInitData     [out]         ݡִгɹڳʼݡ
 * @param  pDataLen      [int,out]     pInitDataЧȡʾpInitDataĻȣִгɹ
 *                                     pInitDataЧȡ
 *
 * @return DONGLE_SUCCESS              ĸȡݳɹ
 */
DWORD WINAPI Dongle_GetInitDataFromMother(DONGLE_HANDLE hDongle, BYTE * pRequest, BYTE * pInitData, int * pDataLen);

/*
 * @brief  ĸķʽȨ޼ɵá
 *
 * @param  hDongle       [in]         򿪵ļ
 * @param  pInitData     [in]         ݡDongle_GetInitDataFromMotherصڳʼݡ
 * @param  nDataLen      [in]         pInitDataݻЧȡ
 *
 * @return DONGLE_SUCCESS             ɹ
 */
DWORD WINAPI Dongle_InitSon(DONGLE_HANDLE hDongle, BYTE * pInitData, int nDataLen);

/**
 * @brief  Զ˽Կ˽ԿΪ1024RSA˽ԿҪȨޡ
 *         ڰȫǣĸĻԶ˽ԿĸеԶ˽Կͬʧܡ
 *
 * @param  hDongle       [in]          򿪵ļ
 * @param  pPriKey       [in]          RSA˽Կ
 *
 * @return DONGLE_SUCCESS              Զ˽Կɹ
 */
DWORD WINAPI Dongle_SetUpdatePriKey(DONGLE_HANDLE hDongle, RSA_PRIVATE_KEY * pPriKey);

/**
 * @brief  ԶݰȨ޼ɵá
 *
 * @param  hDongle         [in]         򿪵ļ
 * @param  pHID            [in]         ӲкšҪ󶨸òΪNULL
 * @param  nFunc           [in]         ͡
 *                                      nFunc = UPDATE_FUNC_CreateFileʾļ
 *                                      nFunc = UPDATE_FUNC_WriteFileдļֻеļſдļ
 *                                      nFunc = UPDATE_FUNC_DeleteFileɾļ
 *                                      nFunc = UPDATE_FUNC_FileLicļȨִֿ֧ļȨ
 *                                      nFunc = UPDATE_FUNC_SeedCount
 *                                      nFunc = UPDATE_FUNC_DownloadExeִļ
 *                                      nFunc = UPDATE_FUNC_UnlockUserPinûPINڰȫǽûPINHID
 *                                      pHIDΪգֻɹɹûPINָΪ"12345678"
 *                                      nFunc = UPDATE_FUNC_Deadlineʱʹޡ
 *
 * @param  nFileType       [in]         ļ͡йļʱļ͡͸òЧ
 * @param  wFileID         [in]         ļIDйļʱļID͸òЧ
 *                                      wFileID=0xFFFFʱʾݡ
 * @param  nOffset         [in]         ƫйļʱļƫ͸òЧ
 * @param  pBuffer         [in]         ݡ
 *                                      nFunc = UPDATE_FUNC_CreateFileʱ, pBufferָҪļԽṹKEY_FILE_ATTR
 *                                      nFunc = UPDATE_FUNC_WriteFileʱ, pBufferָҪдݡ
 *                                      nFunc = UPDATE_FUNC_FileLicʱ, pBufferָļȨ޵ݽṹ磺DATA_LIC
 *                                      nFunc = UPDATE_FUNC_SeedCountʱ, pBufferָlongֵʾ
 *                                      nFunc = UPDATE_FUNC_DownloadExeʱ, pBufferָEXE_FILE_INFOṹDongle_DownloadExeFile÷ơ
 *                                      nFunc = UPDATE_FUNC_Deadlineʱ, pBufferָDWORDֵʾڵʱ䡣
 * @param  nBufferLen      [in]         pBufferĻС
 * @param  pUPubKey        [in]         RSAԿõڵԶ˽ԿӦֵۺͶд
 * @param  pOutData        [out]        ݡݡ
 * @param  pOutDataLen     [in,out]     pOutDataСЧȡ
 *
 * @return DONGLE_SUCCESS               ɹ
 */
DWORD WINAPI Dongle_MakeUpdatePacket(DONGLE_HANDLE hDongle, char * pHID, int nFunc, int nFileType, WORD wFileID, int nOffset, BYTE * pBuffer, int nBufferLen, RSA_PUBLIC_KEY * pUPubKey, BYTE * pOutData, int * pOutDataLen);

/**
 * @brief  ԶݰúĸʽDongle_MakeUpdatePacketԶԿͬȨ޼ɵá
 *
 * @param  hDongle         [in]         򿪵ļ
 * @param  pHID            [in]         ӲкšҪ󶨸òΪNULL
 * @param  nFunc           [in]         ͡
 *                                      nFunc = UPDATE_FUNC_CreateFileʾļ
 *                                      nFunc = UPDATE_FUNC_WriteFileдļֻеļſдļ
 *                                      nFunc = UPDATE_FUNC_DeleteFileɾļ
 *                                      nFunc = UPDATE_FUNC_FileLicļȨִֿ֧ļȨ
 *                                      nFunc = UPDATE_FUNC_SeedCount
 *                                      nFunc = UPDATE_FUNC_DownloadExeִļ
 *                                      nFunc = UPDATE_FUNC_UnlockUserPinûPINڰȫǽûPINHID
 *                                      pHIDΪգֻɹɹûPINָΪ"12345678"
 *                                      nFunc = UPDATE_FUNC_Deadlineʱʹޡ
 *
 * @param  nFileType       [in]         ļ͡йļʱļ͡͸òЧ
 * @param  wFileID         [in]         ļIDйļʱļID͸òЧ
 *                                      wFileID=0xFFFFʱʾݡ
 * @param  nOffset         [in]         ƫйļʱļƫ͸òЧ
 * @param  pBuffer         [in]         ݡ
 *                                      nFunc = UPDATE_FUNC_CreateFileʱ, pBufferָҪļԽṹKEY_FILE_ATTR
 *                                      nFunc = UPDATE_FUNC_WriteFileʱ, pBufferָҪдݡ
 *                                      nFunc = UPDATE_FUNC_FileLicʱ, pBufferָļȨ޵ݽṹ磺DATA_LIC
 *                                      nFunc = UPDATE_FUNC_SeedCountʱ, pBufferָlongֵʾ
 *                                      nFunc = UPDATE_FUNC_DownloadExeʱ, pBufferָEXE_FILE_INFOṹDongle_DownloadExeFile÷ơ
 *                                      nFunc = UPDATE_FUNC_Deadlineʱ, pBufferָDWORDֵʾڵʱ䡣
 * @param  nBufferLen      [in]         pBufferĻС
 * @param  pOutData        [out]        ݡݡ
 * @param  pOutDataLen     [in,out]     pOutDataСЧȡ
 *
 * @return DONGLE_SUCCESS               ɹ
 */
DWORD WINAPI Dongle_MakeUpdatePacketFromMother(DONGLE_HANDLE hDongle, char * pHID, int nFunc, int nFileType, WORD wFileID, int nOffset, BYTE * pBuffer, int nBufferLen, BYTE * pOutData, int * pOutDataLen);

/**
 * @brief  ԶеݡȨ޼ɡpUpdateDataһֻʹһΡ
 *         1.ڲǰ1024ֽڵķֿƷ,ֵDONGLE_SUCCESSжϷͲء
 *         2.Ҫ̿,ɵ÷ֿ(ÿ1024ֽ)֤ͣݿ˳򲻱ңݷصĴ̡
 *
 * @param  hDongle         [in]     򿪵ļ
 * @param  pUpdateData     [in]     ݡݣDongle_MakeUpdatePacketDongle_MakeUpdatePacketFromMother
 * @param  nDataLen        [in]     pUpdateDataĴСΪ1024
 *
 * @return DONGLE_SUCCESS           ɹ
 */
DWORD WINAPI Dongle_Update(DONGLE_HANDLE hDongle, BYTE * pUpdateData, int nDataLen);


//
#define   DONGLE_SUCCESS                       0x00000000          // ɹ
#define   DONGLE_NOT_FOUND                     0xF0000001          // δҵָ豸
#define   DONGLE_INVALID_HANDLE				   0xF0000002		   // Чľ
#define   DONGLE_INVALID_PARAMETER			   0xF0000003		   // 
#define   DONGLE_COMM_ERROR					   0xF0000004		   // ͨѶ
#define   DONGLE_INSUFFICIENT_BUFFER		   0xF0000005		   // ռ䲻
#define   DONGLE_NOT_INITIALIZED               0xF0000006		   // Ʒδʼ (ûPID)
#define   DONGLE_ALREADY_INITIALIZED		   0xF0000007		   // ƷѾʼ (PID)
#define   DONGLE_ADMINPIN_NOT_CHECK			   0xF0000008		   // û֤
#define   DONGLE_USERPIN_NOT_CHECK			   0xF0000009		   // ûû֤
#define   DONGLE_INCORRECT_PIN				   0xF000FF00		   // 벻ȷ (2λָʾʣ)
#define   DONGLE_PIN_BLOCKED				   0xF000000A		   // PIN
#define   DONGLE_ACCESS_DENIED				   0xF000000B		   // ʱܾ 
#define   DONGLE_FILE_EXIST					   0xF000000E		   // ļѴ
#define   DONGLE_FILE_NOT_FOUND				   0xF000000F		   // δҵָļ
#define	  DONGLE_READ_ERROR                    0xF0000010          // ȡݴ
#define	  DONGLE_WRITE_ERROR                   0xF0000011          // дݴ
#define	  DONGLE_FILE_CREATE_ERROR             0xF0000012          // ļ
#define	  DONGLE_FILE_READ_ERROR               0xF0000013          // ȡļ
#define	  DONGLE_FILE_WRITE_ERROR              0xF0000014          // дļ
#define	  DONGLE_FILE_DEL_ERROR                0xF0000015          // ɾļ
#define   DONGLE_FAILED                        0xF0000016          // ʧ
#define   DONGLE_CLOCK_EXPIRE                  0xF0000017          // ʱӵ
#define   DONGLE_ERROR_UNKNOWN		           0xFFFFFFFF		   // δ֪Ĵ

#ifdef __cplusplus 
}
#endif

#endif